Updating multus, SRIOV and nfd test cases
[multicloud/k8s.git] / kud / tests / _functions.sh
index 5e6314c..7687f3f 100755 (executable)
@@ -12,9 +12,10 @@ set -o errexit
 set -o nounset
 set -o pipefail
 
-FUNCTIONS_DIR=$(cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd)
+FUNCTIONS_DIR="$(readlink -f "$(dirname "${BASH_SOURCE[0]}")")"
 
 source /etc/environment
+source $FUNCTIONS_DIR/_common_test.sh
 
 function print_msg {
     local msg=$1
@@ -25,12 +26,74 @@ function print_msg {
 }
 
 function get_ovn_central_address {
-    ansible_ifconfig=$(ansible ovn-central[0] -i ${FUNCTIONS_DIR}/../hosting_providers/vagrant/inventory/hosts.ini -m shell -a "ifconfig ${OVN_CENTRAL_INTERFACE} |grep \"inet addr\" |awk '{print \$2}' |awk -F: '{print \$2}'")
-    if [[ $ansible_ifconfig != *CHANGED* ]]; then
-        echo "Fail to get the OVN central IP address from ${OVN_CENTRAL_INTERFACE} nic"
-        exit
+    #Reuse OVN_CENTRAL_ADDRESS if available (bypassable by --force flag)
+    if [[ "${1:-}" != "--force" ]] && [[ -n "${OVN_CENTRAL_ADDRESS:-}" ]]; then
+        echo "${OVN_CENTRAL_ADDRESS}"
+        return 0
+    fi
+
+    local remote_command="ip address show dev $OVN_CENTRAL_INTERFACE primary"
+    declare -a ansible_command=(ansible ovn-central[0] -i \
+                "${FUNCTIONS_DIR}/../hosting_providers/vagrant/inventory/hosts.ini")
+    declare -a filter=(awk -F '[ \t/]+' \
+                'BEGIN {r=1} {for (i=1; i<=NF; i++) if ($i == "inet") {print $(i+1); r=0}} END {exit r}')
+    local result
+
+    #Determine OVN_CENTRAL_INTERFACE address
+    if ! result="$("${ansible_command[@]}" -a "${remote_command}")"; then
+        echo "Ansible error for remote host ovn-central[0]" >&2
+        return 1
+    else
+        if [[ "${result}" != *CHANGED* ]]; then
+            echo "Failed to execute command on remote host ovn-central[0]" >&2
+            return 2
+        else
+            if ! result="$("${filter[@]}" <<< "${result}")"; then
+                echo "Failed to retrieve interface address from command output" >&2
+                return 3
+            else
+                echo "${result}:6641"
+            fi
+        fi
+    fi
+}
+
+function call_api {
+    #Runs curl with passed flags and provides
+    #additional error handling and debug information
+
+    #Function outputs server response body
+    #and performs validation of http_code
+
+    local status
+    local curl_response_file="$(mktemp -p /tmp)"
+    local curl_common_flags=(-s -w "%{http_code}" -o "${curl_response_file}")
+    local command=(curl "${curl_common_flags[@]}" "$@")
+
+    echo "[INFO] Running '${command[@]}'" >&2
+    if ! status="$("${command[@]}")"; then
+        echo "[ERROR] Internal curl error! '$status'" >&2
+        cat "${curl_response_file}"
+        rm "${curl_response_file}"
+        return 2
+    else
+        echo "[INFO] Server replied with status: ${status}" >&2
+        cat "${curl_response_file}"
+        rm "${curl_response_file}"
+        if [[ "${status:0:1}" =~ [45] ]]; then
+            return 1
+        else
+            return 0
+        fi
     fi
-    echo "$(echo ${ansible_ifconfig#*>>} | tr '\n' ':')6641"
+}
+
+function delete_resource {
+    #Issues DELETE http call to provided endpoint
+    #and further validates by following GET request
+
+    call_api -X DELETE "$1"
+    ! call_api -X GET "$1" >/dev/null
 }
 
 # init_network() - This function creates the OVN resouces required by the test
@@ -111,6 +174,48 @@ function wait_deployment {
     done
 }
 
+# wait_for_pod() - Wait until first pod matched by kubectl filters is in running status
+function wait_for_pod {
+    #Example usage:
+    # wait_for_pods example_pod
+    # wait_for_pods --namespace test different_pod
+    # wait_for_pods -n test -l app=plugin_test
+
+    status_phase=""
+    while [[ "$status_phase" != "Running" ]]; do
+        new_phase="$(kubectl get pods -o 'go-template={{ index .items 0 "status" "phase" }}' "$@" )"
+        if [[ "$new_phase" != "$status_phase" ]]; then
+            echo "$(date +%H:%M:%S) - Filter=[$*] : $new_phase"
+            status_phase="$new_phase"
+        fi
+        if [[ "$new_phase" == "Err"* ]]; then
+            exit 1
+        fi
+    done
+}
+
+# wait_for_deployment() - Wait until the deployment is ready
+function wait_for_deployment {
+    #Example usage:
+    # wait_for_deployment $DEPLOYMENT_NAME $REPLICAS
+    # wait_for_deployment example_deployment 2
+
+    status="0/"
+
+    while [[ "$status" != $2* ]]; do
+        new_status=`kubectl get deployment -A | grep $1 | awk '{print $3}'`
+        if [[ "$new_status" != "$status" ]]; then
+            status="$new_status"
+        fi
+
+        pod_status=`kubectl get pods -A | grep $1 | awk '{print $4}'`
+        if [[ $pod_status =~ "Err" ]]; then
+            echo "Deployment $1 error"
+            exit 1
+        fi
+    done
+}
+
 # setup() - Base testing setup shared among functional tests
 function setup {
     if ! $(kubectl version &>/dev/null); then
@@ -132,4 +237,33 @@ function teardown {
         destroy_deployment $deployment_name
     done
 }
+
+# check_ip_range() - Verifying IP address in address range
+function check_ip_range {
+    local IP=$1
+    local MASK=$2
+
+    install_ipcalc
+
+    if [[ ! -e /usr/bin/ipcalc ]]; then
+        echo -e "Command 'ipcalc' not found"
+        return 0
+    fi
+
+    if [[ -z ${IP} ]] || [[ -z ${MASK} ]]; then
+            return 1
+    fi
+    min=`/usr/bin/ipcalc $MASK|awk '/HostMin:/{print $2}'`
+    max=`/usr/bin/ipcalc $MASK|awk '/HostMax:/{print $2}'`
+    MIN=`echo $min|awk -F"." '{printf"%.0f\n",$1*256*256*256+$2*256*256+$3*256+$4}'`
+    MAX=`echo $max|awk -F"." '{printf"%.0f\n",$1*256*256*256+$2*256*256+$3*256+$4}'`
+    IPvalue=`echo $IP|awk -F"." '{printf"%.0f\n",$1*256*256*256+$2*256*256+$3*256+$4}'`
+    if [[ "$IPvalue" -gt "$MIN" ]] && [[ "$IPvalue" -lt "$MAX" ]]; then
+        echo -e "$IP in ipset $MASK"
+        return 0
+    fi
+    echo -e "$IP not in ipset $MASK"
+    return 1
+}
+
 test_folder=${FUNCTIONS_DIR}